<context-menu #basicMenu>
  <ng-template contextMenuItem (execute)="createNewCours($event.item)">
    Ajouter un cours
  </ng-template>
</context-menu>

<ng-template #monthCellTemplate let-day="day" let-openDay="openDay" let-locale="locale"
  let-tooltipPlacement="tooltipPlacement" let-highlightDay="highlightDay" let-unhighlightDay="unhighlightDay"
  let-eventClicked="eventClicked">
  <div class="fill-height" [contextMenu]="basicMenu" [contextMenuSubject]="day.date">
    <div class="cal-cell-top">
      <span class="cal-day-badge" *ngIf="day.badgeTotal > 0">{{
        day.badgeTotal
      }}</span>
      <span class="cal-day-number">{{
        day.date | calendarDate: "monthViewDayNumber":locale
      }}</span>
    </div>
    <div class="cal-events">
      <div class="cal-event" *ngFor="let event of day.events" [style.backgroundColor]="event.color.primary"
        [ngClass]="event?.cssClass" (mouseenter)="highlightDay.emit({ event: event })"
        (mouseleave)="unhighlightDay.emit({ event: event })" [mwlCalendarTooltip]="
          event.title | calendarEventTitle: 'monthTooltip':event
        " [tooltipPlacement]="tooltipPlacement"
        (click)="$event.stopPropagation(); eventClicked.emit({ event: event })"></div>
    </div>
  </div>
</ng-template>

<ng-template #weekHeaderTemplate let-days="days" let-locale="locale" let-dayHeaderClicked="dayHeaderClicked">
  <div class="cal-day-headers">
    <div class="cal-header" *ngFor="let day of days" [class.cal-past]="day.isPast" [class.cal-today]="day.isToday"
      [class.cal-future]="day.isFuture" [class.cal-weekend]="day.isWeekend"
      (click)="dayHeaderClicked.emit({ day: day })" [contextMenu]="basicMenu" [contextMenuSubject]="day.date">
      <div>
        {{ day.date | calendarDate: "weekViewColumnHeader":locale }}
      </div>
      <br />
      <span>{{
        day.date | calendarDate: "weekViewColumnSubHeader":locale
      }}</span>
    </div>
  </div>
</ng-template>
<ng-template #dayHourSegmentTemplate let-segment="segment" let-locale="locale">
  <div class="cal-hour-segment" [ngClass]="segment.cssClass" [contextMenu]="basicMenu"
    [contextMenuSubject]="segment.date">
    <div [hidden]="!segment.isStart" class="cal-time">
      {{ segment.date | calendarDate: "dayViewHour":locale }}
    </div>
  </div>
</ng-template>
<div class="row text-center">
  <div class="col-md-4">
    <div class="btn-group">
      <button class="btn btn-primary" mwlCalendarPreviousView [view]="view" [(viewDate)]="viewDate"
        [disabled]="prevBtnDisabled" (click)="previous()" (viewDateChange)="activeDayIsOpen = false">
        Précedent
      </button>
      <button class="btn btn-outline-secondary" mwlCalendarToday (click)="today()" [(viewDate)]="viewDate">
        Aujourd'hui
      </button>
      <button class="btn btn-primary" mwlCalendarNextView [view]="view" [(viewDate)]="viewDate"
        [disabled]="nextBtnDisabled" (click)="next()" (viewDateChange)="activeDayIsOpen = false">
        Suivant
      </button>
    </div>
  </div>
  <div class="col-md-4">
    <h3>{{ viewDate | calendarDate: view + "ViewTitle":"fr" }}</h3>
  </div>
  <div class="col-md-4">
    <div class="btn-group">
      <div class="btn btn-primary" (click)="changeView(CalendarView.Month)"
        [class.active]="view === CalendarView.Month">
        Mois
      </div>
      <div class="btn btn-primary" (click)="changeView(CalendarView.Week)" [class.active]="view === CalendarView.Week">
        Semaine
      </div>
      <div class="btn btn-primary" (click)="changeView(CalendarView.Day)" [class.active]="view === CalendarView.Day">
        Jour
      </div>
    </div>
  </div>
</div>
<br />
<div [ngSwitch]="view" class="calendar">
  <mwl-calendar-month-view *ngSwitchCase="CalendarView.Month" [viewDate]="viewDate" [events]="skiingLessons"
    [refresh]="refresh" [activeDayIsOpen]="activeDayIsOpen" [cellTemplate]="monthCellTemplate"
    (dayClicked)="dayClicked($event.day)" (eventClicked)="showDayDetails()"
    (beforeViewRender)="beforeMonthViewRender($event)">
  </mwl-calendar-month-view>
  <mwl-calendar-week-view *ngSwitchCase="CalendarView.Week" [viewDate]="viewDate" [events]="skiingLessons"
    [refresh]="refresh" (eventClicked)="showDayDetails()" [headerTemplate]="weekHeaderTemplate">
  </mwl-calendar-week-view>
  <mwl-calendar-day-view *ngSwitchCase="CalendarView.Day" [viewDate]="viewDate" [events]="skiingLessons"
    [refresh]="refresh" (eventClicked)="showDayDetails()" [hourSegmentTemplate]="dayHourSegmentTemplate">
  </mwl-calendar-day-view>
</div>
